VERSION 5.00
Begin VB.Form frmClipViewer 
   Appearance      =   0  'Flat
   Caption         =   "Clipboard Viewer"
   ClientHeight    =   4785
   ClientLeft      =   1200
   ClientTop       =   2445
   ClientWidth     =   7980
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "FClipView.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4785
   ScaleWidth      =   7980
   Begin VB.TextBox Text1 
      Height          =   1500
      Left            =   2580
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "FClipView.frx":000C
      Top             =   0
      Visible         =   0   'False
      Width           =   2220
   End
   Begin VB.PictureBox Picture1 
      Height          =   1500
      Left            =   0
      ScaleHeight     =   96
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   156
      TabIndex        =   0
      Top             =   0
      Width           =   2400
   End
   Begin VB.Menu mnuMain 
      Caption         =   "&File"
      Index           =   0
      Begin VB.Menu mnuFile 
         Caption         =   "&New Window"
         Index           =   0
      End
      Begin VB.Menu mnuFile 
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu mnuFile 
         Caption         =   "&Close"
         Index           =   2
      End
      Begin VB.Menu mnuFile 
         Caption         =   "E&xit"
         Index           =   3
      End
   End
   Begin VB.Menu mnuMain 
      Caption         =   "&Edit"
      Index           =   1
      Begin VB.Menu mnuEdit 
         Caption         =   "&Delete"
         Index           =   0
         Shortcut        =   {DEL}
      End
   End
   Begin VB.Menu mnuMain 
      Caption         =   "&Display"
      Index           =   2
      Begin VB.Menu mnuDisplayAuto 
         Caption         =   "Auto"
      End
      Begin VB.Menu mnuDisplayBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDisplay 
         Caption         =   "ClipFormat"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmClipViewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************
'  Copyright (C)1995-98, Karl E. Peterson
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

' Note: ALWAYS stop this application via its control
'       menu when running within the VB IDE!!!
'       Failure to do so will corrupt the clipboard
'       viewer chain.

' Static handle to next window in clipboard chain
Private m_hWndNext As Long

' Static var to hold current clipboard format
Private m_ClipFmt As Long

' **************************************************************
'  Subclassing
' **************************************************************
Public Function WindowProc(hWnd As Long, msg As Long, wp As Long, lp As Long) As Long
   '
   ' VB Windows don't normally handle clipboard messages,
   ' so go ahead and let it do what it wants to first.
   '
   WindowProc = InvokeWindowProc(hWnd, msg, wp, lp)
   '
   ' Take appropriate action based on incoming message.
   '
   ' Each window that receives the either of these messages should
   ' call the SendMessage function to pass the message on to the
   ' next window in the clipboard-viewer chain.
   '
   Select Case msg
      Case WM_CHANGECBCHAIN
         '
         ' If the window being removed is the next window in the
         ' chain, the window specified by the m_hWndNext parameter
         ' becomes the next window and clipboard messages are
         ' passed on to it.
         '
         If wp = m_hWndNext Then
            m_hWndNext = lp
         End If
         Call SendMessage(m_hWndNext, msg, wp, lp)

      Case WM_DRAWCLIPBOARD
         '
         ' Contents of clipboard have changed.
         ' Call routine to read.
         '
         UpdateClipViewAuto
         UpdateDisplayMenu mnuDisplay
         Call SendMessage(m_hWndNext, msg, wp, lp)
   End Select
End Function

' **************************************************************
'  Public Methods
' **************************************************************
Public Sub UpdateCaption(ByVal ViewType As String)
   Me.Caption = App.Title & ": " & ViewType
End Sub

' **************************************************************
'  Private Object Events
' **************************************************************
Private Sub Form_Load()
   '
   ' Rearrange controls and form
   '
   With Text1
      .Visible = False
      .Text = ""
   End With
   With Picture1
      .Visible = False
      .Top = Picture1.Left
      .AutoRedraw = True
   End With
   App.Title = Me.Caption
   '
   ' Setup window hook
   '
   Call HookWindow(Me.hWnd, Me)
'   Msghook1.HwndHook = Me.hWnd
'   Msghook1.Message(WM_CHANGECBCHAIN) = True
'   Msghook1.Message(WM_DRAWCLIPBOARD) = True
   '
   ' Paint whatever's in the clipboard currently
   '
   UpdateClipViewAuto
   UpdateDisplayMenu mnuDisplay
   '
   ' Install app in viewer chain
   '
   m_hWndNext = SetClipboardViewer(hWnd)
End Sub

Private Sub Form_Resize()
   '
   ' Adjust control positions
   '
   With Picture1
      .Move .Left, .Top, Me.Width - 2 * .Left - (Me.Width - Me.ScaleWidth), Me.Height - 2 * .Top - (Me.Height - Me.ScaleHeight)
      Text1.Move .Left, .Top, .Width, .Height
   End With
   '
   ' Repaint view
   '
   If m_ClipFmt = CF_OWNERDISPLAY Or _
      m_ClipFmt = CF_METAFILEPICT Or _
      m_ClipFmt = CF_DSPMETAFILEPICT Or _
      m_ClipFmt = CF_ENHMETAFILE Or _
      m_ClipFmt = CF_PALETTE Then
         UpdateClipView
   End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Dim nRet As Long
   '
   ' Remove Me from the clipboard viewer chain.
   ' DO NOT stop execution from VB menu or toolbar!
   '
   With Me
      Call ChangeClipboardChain(.hWnd, m_hWndNext)
      Call UnhookWindow(.hWnd)
   End With
End Sub

Private Sub mnuDisplay_Click(Index As Integer)
   m_ClipFmt = mnuDisplay(Index).Tag
   mnuDisplayAuto.Checked = False
   UpdateClipView
End Sub

Private Sub mnuDisplayAuto_Click()
   Call UpdateClipViewAuto
End Sub

Private Sub mnuEdit_Click(Index As Integer)
   Const edtDelete = 0
   Select Case Index
      Case edtDelete
         If MsgBox("Clear contents of the Clipboard?", _
                 vbYesNo Or vbDefaultButton1 Or vbQuestion, _
                 "Clear Clipboard") = vbYes Then
            Clipboard.Clear
         End If
   End Select
End Sub

Private Sub mnuFile_Click(Index As Integer)
   Const filNew = 0
   Const filClose = 2
   Const filExit = 3
   Select Case Index
      Case filNew
         MClipMain.ViewerNew Me
      Case filClose
         Unload Me
      Case filExit
         MClipMain.ViewerCloseAll
   End Select
End Sub

' **************************************************************
'  Private Methods
' **************************************************************
Private Function UpdateClipViewAuto() As Boolean
   Static Busy As Boolean
   ReDim PriorityList(0 To 20) As Long
   Dim mnu As Menu

   If Busy Then Exit Function
   
   If CountClipFormats > 0 Then
      Busy = True
      PriorityList(0) = CF_OWNERDISPLAY
      PriorityList(1) = CF_TEXT
      PriorityList(2) = CF_ENHMETAFILE
      PriorityList(3) = CF_BITMAP
      PriorityList(4) = CF_HDROP
      m_ClipFmt = GetPriorityClipboardFormat(PriorityList(0), 5)
      UpdateClipViewAuto = UpdateClipView
      
      For Each mnu In mnuDisplay
         mnu.Checked = False
      Next mnu
      mnuDisplayAuto.Checked = True
      mnuMain(2).Enabled = True
   Else
      Text1.Visible = False
      Text1.Text = ""
      Set Picture1.Picture = Nothing
      Picture1.Visible = True
      Me.UpdateCaption "Clipboard is Empty"
      mnuMain(2).Enabled = False
   End If
   Busy = False
End Function

Private Function UpdateClipView() As Boolean
   Dim nRet As Boolean
   Dim bAuto As Boolean
   Dim mnu As Menu
   
   Picture1.Visible = False
   Set Picture1.Picture = Nothing
   Text1.Visible = False
   
   Select Case m_ClipFmt
      Case 0
         bAuto = True
         nRet = UpdateClipViewAuto
   
      Case CF_TEXT, CF_OEMTEXT, CF_DSPTEXT
         nRet = DisplayText(m_ClipFmt, Text1)
         Text1.Visible = True
         
      Case CF_HDROP
         nRet = DisplayFileList(Text1)
         Text1.Visible = True
      
      Case CF_BITMAP, CF_DSPBITMAP, _
           CF_METAFILEPICT, CF_DSPMETAFILEPICT, CF_ENHMETAFILE
         Picture1.Visible = True
         nRet = DisplayPicture(m_ClipFmt, Picture1)
         
      Case CF_PALETTE
         Picture1.Visible = True
         nRet = DisplayPalette(Picture1)
      
      Case CF_LOCALE
         nRet = DisplayLocale(Text1)
         Text1.Visible = True
         
      Case CF_OWNERDISPLAY
         Picture1.Visible = True
         nRet = DisplayOwnerDisplay(Picture1)
         
      Case Else
         bAuto = True
         nRet = UpdateClipViewAuto
   End Select
   
   If nRet = False Then
      Me.UpdateCaption "No Supported Format"
      For Each mnu In mnuDisplay
         mnu.Checked = False
      Next mnu
   ElseIf bAuto = False Then
      For Each mnu In mnuDisplay
         mnu.Checked = (CLng(Val(mnu.Tag)) = m_ClipFmt)
      Next mnu
   End If
   UpdateClipView = nRet
End Function

'Private Sub Msghook1_Message(ByVal msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
'   '
'   ' VB Windows don't normally handle clipboard messages,
'   ' so go ahead and let it do what it wants to first.
'   '
'   result = Msghook1.InvokeWindowProc(msg, wp, lp)
'   '
'   ' Take appropriate action based on incoming message.
'   '
'   ' Each window that receives the either of these messages should
'   ' call the SendMessage function to pass the message on to the
'   ' next window in the clipboard-viewer chain.
'   '
'   Select Case msg
'      Case WM_CHANGECBCHAIN
'         '
'         ' If the window being removed is the next window in the
'         ' chain, the window specified by the m_hWndNext parameter
'         ' becomes the next window and clipboard messages are
'         ' passed on to it.
'         '
'         If wp = m_hWndNext Then
'            m_hWndNext = lp
'         End If
'         Call SendMessage(m_hWndNext, msg, wp, lp)
'
'      Case WM_DRAWCLIPBOARD
'         '
'         ' Contents of clipboard have changed.
'         ' Call routine to read.
'         '
'         UpdateClipViewAuto
'         UpdateDisplayMenu mnuDisplay
'         Call SendMessage(m_hWndNext, msg, wp, lp)
'   End Select
'End Sub
